"""RecordType as Enum

Revision ID: 7812741cc469
Revises: 73541c7b7aa6
Create Date: 2021-05-19 12:46:11.497572

"""
from alembic import op
import sqlalchemy as sa
from enum import Enum

# revision identifiers, used by Alembic.
revision = "7812741cc469"
down_revision = "73541c7b7aa6"
branch_labels = None
depends_on = None


class RecordType(Enum):
    float_vector = 1
    file = 2


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    enum_type = sa.dialects.postgresql.ENUM(RecordType, name="recordtype")
    enum_type.create(op.get_bind())
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column(
        table_name="record",
        column_name="record_type",
        type_=sa.Enum(RecordType),
        postgresql_using="""
case record_type
    when 1 then 'float_vector'
    when 2 then 'file'
end :: recordtype;
""",
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column(
        "record",
        "record_type",
        type_=sa.Integer,
    )
    op.execute("DROP TYPE recordtype")
    # ### end Alembic commands ###
